package com.ReactNativeVoipPushReceiver;

import java.util.Map;
import com.google.firebase.messaging.FirebaseMessagingService;
import com.google.firebase.messaging.RemoteMessage;

import android.app.ActivityManager;
import android.app.ActivityManager.RunningAppProcessInfo;
import android.app.Application;
import android.os.Handler;
import android.os.HandlerThread;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.PowerManager;
import android.os.Process;
import android.util.Log;

import androidx.localbroadcastmanager.content.LocalBroadcastManager;

import com.facebook.react.bridge.Arguments;
import com.facebook.react.ReactApplication;
import com.facebook.react.ReactInstanceManager;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.WritableMap;

import org.json.JSONObject;

import java.util.List;
import java.util.Random;

public class RNVoipPushReceiverHandler extends FirebaseMessagingService {

    private static String TAG = "RNVoipPushReceiverHandler";

    private PowerManager mPowerManager;

    private Handler mHandler;

    private HandlerThread mWorkerThread;

    @Override
    public void onMessageReceived(RemoteMessage message) {
        String from = message.getFrom();
        RemoteMessage.Notification remoteNotification = message.getNotification();

        // VoIP notifications must be null - If notification body exists, this is not VoIP
        if (remoteNotification != null) return;

        // Automatically start application when incoming call received.
        if (isApplicationInForeground() == false) {
            try {
                String ns = getApplicationContext().getPackageName();
                String cls = ns + ".MainActivity";

                Intent intent = new Intent(getApplicationContext(), Class.forName(cls));
                intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.EXTRA_DOCK_STATE_CAR);
                intent.addCategory(Intent.CATEGORY_LAUNCHER);
                intent.putExtra("foreground", true);

                startActivity(intent);

                LocalBroadcastManager localBroadcastManager = LocalBroadcastManager.getInstance(this);
                Intent registerDeviceEvent = new Intent("register-device-event");
                localBroadcastManager.sendBroadcast(registerDeviceEvent);
            } catch (Exception e) {
                Log.w(TAG, "Failed to open application on received call", e);
            }
        }

        // job(new Runnable() {
        //     @Override
        //     public void run() {
        //         mPowerManager = (PowerManager) getApplicationContext().getSystemService(POWER_SERVICE);
        //         mHandler = new Handler(mWorkerThread.getLooper());
        //         mWorkerThread = new HandlerThread(getClass().getSimpleName(), Process.THREAD_PRIORITY_FOREGROUND);
        //         mWorkerThread.setPriority(Thread.MAX_PRIORITY);
        //         mWorkerThread.start();
        //         // Brighten screen at least 10 seconds
        //         PowerManager.WakeLock wl = mPowerManager.newWakeLock(
        //             PowerManager.ACQUIRE_CAUSES_WAKEUP | PowerManager.ON_AFTER_RELEASE | PowerManager.FULL_WAKE_LOCK,
        //             "incoming_call"
        //         );
        //         wl.acquire(10000);
        //     }
        // });
    }

    private void job(Runnable job) {
        mHandler.post(job);
    }

    private JSONObject getPushData(String dataString) {
        try {
            return new JSONObject(dataString);
        } catch (Exception e) {
            return null;
        }
    }

    private boolean isApplicationInForeground() {
        ActivityManager activityManager = (ActivityManager) this.getSystemService(ACTIVITY_SERVICE);
        List<RunningAppProcessInfo> processInfos = activityManager.getRunningAppProcesses();
        if (processInfos != null) {
            for (RunningAppProcessInfo processInfo : processInfos) {
                if (processInfo.processName.equals(getApplication().getPackageName())) {
                    if (processInfo.importance == RunningAppProcessInfo.IMPORTANCE_FOREGROUND) {
                        for (String d : processInfo.pkgList) {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }
}
