import {
  NativeModules,
  NativeEventEmitter,
  Platform,
} from 'react-native';

const { RNVoipPushReceiver, RNVoipPushReceiverHandler } = NativeModules;

class AndroidVoipPushReceiverListener {
  listeners = [];

  constructor() {
    if (Platform.OS !== 'android') return;

    const eventEmitter = new NativeEventEmitter(RNVoipPushReceiverHandler);
    eventEmitter.addListener('VoipPushReceived', (event) => {
      this.listeners.forEach(listener => listener());
    });
  }

  setNotificationReceivedListener(listener) {
    this.listeners.push(listener);
  }
}

const AndroidVoipPushReceiver = new AndroidVoipPushReceiverListener();

export default RNVoipPushReceiver;
export {
  AndroidVoipPushReceiver,
};
